unit uHelloDigi;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, OleCtrls, voicerlibLib_TLB, ShellApi;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    cmdIniciaVoicerLib: TButton;
    cmdFinalizaVoicerlib: TButton;
    cmdLeiaMe: TButton;
    Label1: TLabel;
    txtPorta: TEdit;
    Label2: TLabel;
    txtTempoGravacao: TEdit;
    Panel2: TPanel;
    cmdLimpaLog: TButton;
    memStatus: TMemo;
    Panel3: TPanel;
    voicerlib1: Tvoicerlib;
    Label3: TLabel;
    txtLimiar: TEdit;
    Label4: TLabel;
    txtTempoSilencio: TEdit;
    Panel4: TPanel;
    lblStatus: TLabel;
    lblStatus1: TLabel;
    Image1: TImage;
    procedure cmdIniciaVoicerLibClick(Sender: TObject);
    procedure cmdFinalizaVoicerlibClick(Sender: TObject);
    procedure cmdLeiaMeClick(Sender: TObject);
    procedure cmdLimpaLogClick(Sender: TObject);
    procedure voicerlib1RingDetected(ASender: TObject; Port: Smallint);
    procedure voicerlib1AfterPickup(ASender: TObject; Port: Smallint);
    procedure voicerlib1RecordStop(ASender: TObject; Port,
      StopStatus: Smallint);
    procedure voicerlib1Recording(ASender: TObject; Port: Smallint;
      ElapsedTime: Integer);
    procedure voicerlib1PlayStop(ASender: TObject; Port,
      StopStatus: Smallint);
    procedure voicerlib1BusyDetected(ASender: TObject; Port: Smallint);
    procedure voicerlib1SilenceDetected(ASender: TObject; Port,
      State: Smallint);
    procedure FormCreate(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  nFlag : Integer;
  nTotalPortas : Integer;
  nTotalPlacas : Integer;
  nContSilencio: Integer;
  sReturn    : array [0..255] of Char;

implementation

{$R *.dfm}

{**********************************************************
  Esta procedure coloca na tela os estados do programa
  com hora e a porta
**********************************************************}
procedure MostraStatus(nPorta: integer; sMess: string);
var
  sMsg: string;
begin
  if (nPorta > 0) then
    sMsg := '<' + TimeToStr(Time) + '> - (Porta ' + IntToStr(nPorta) + ') - ' +sMess
  else
    sMsg := '<' + TimeToStr(Time) + '> - ' + sMess;
  Form1.memStatus.Lines.Add(sMsg);
end;

procedure TForm1.cmdIniciaVoicerLibClick(Sender: TObject);
var
  nRet,i : Integer;
begin
  nFlag := 0;

  //Verifica se o driver esta habilitado
  if voicerlib1.DriverEnabled then
    MostraStatus(0,'Driver ja inicializado')
  else
  begin
    //Inicializa a placa
    nRet := voicerlib1.StartVoicerLib;
    //Trata o retorno da inicializacao
    voicerlib1.ReturnCodeToString(nRet,Cardinal(@sReturn));

    //Testa o retorno do StartVoicerLib
    if nRet = DG_EXIT_SUCCESS then
    begin
      MostraStatus(0,'VoicerLib Inicializada com Sucesso');
      nTotalPortas := voicerlib1.GetPortsCount;
      nTotalPlacas := voicerlib1.GetCardsCount;
      lblStatus.Caption := 'Nmero Total de Placas: ' + IntToStr(nTotalPlacas);
      lblStatus1.Caption := 'Nmero Total de Portas: ' + IntToStr(nTotalPortas);

      for i:=1 to nTotalPortas do
      begin
        //Permite alterar o limiar para deteco de atendimento
        voicerlib1.SetSilenceThreshold(i,StrToInt(txtLimiar.Text));

        //Inicia o tratamento automatico de supervisao de linha
        nRet := voicerlib1.CreateCallProgress(i,'cp_default.cfg');

        if nRet <> DG_EXIT_SUCCESS then
          MostraStatus(i,'Erro ao executar Superviso de Linha CreateCallProgress.Ret.:' + IntToStr(nRet));
      end;
    end
    else
      MostraStatus(0,'Erro ao inicializar a VoicerLib. Erro -> ' + sReturn);
  end;

end;

procedure TForm1.cmdFinalizaVoicerlibClick(Sender: TObject);
var
  ret,i: integer;
begin
  if VoicerLib1.DriverEnabled then
  begin
    for i:=1 to nTotalPortas do
    begin
      //Finaliza a supervisao de linha
      voicerlib1.DestroyCallProgress(i);
      //Desabilita a deteccao de silencio
      voicerlib1.DisableSilenceDetection(i);
    end;
      
    //Desliga a Placa
    ret:= voicerlib1.ShutdownVoicerLib;
    //Testa se desligou corretamente
    if ret <> DG_EXIT_SUCCESS then
      MostraStatus(0,'Erro na finalizao. Recomenda-se reiniciar o micro')
    else
      MostraStatus(0,'VoicerLib finalizada com sucesso');
  end;
end;

procedure TForm1.cmdLeiaMeClick(Sender: TObject);
var
  L:String;
begin
  L:= ExtractFilePath(Application.ExeName) + 'Leiame.txt';
  ShellExecute(0 ,nil,PChar(L), nil, nil,SW_NORMAL);
end;

procedure TForm1.cmdLimpaLogClick(Sender: TObject);
begin
  memStatus.Clear;
end;

procedure TForm1.voicerlib1RingDetected(ASender: TObject; Port: Smallint);
begin
  try
    //Atende a Ligacao
    voicerlib1.PickUp(Port,1000);
    MostraStatus(Port,'Atendeu a chamada...');
  except
    Application.MessageBox('Erro ao Atender chamada', 'Except', mb_OK);
  end;
end;

procedure TForm1.voicerlib1AfterPickup(ASender: TObject; Port: Smallint);
var
  sArq : String;
  nRet : Integer;
begin

  try
    //Habilita superviso de linha
    nRet := VoicerLib1.EnableCallProgress(Port,CP_ENABLE_BUSY_OR_FAX);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'AfterPickup -> Erro ao habilitar CallProgress ALL.Ret.:' + IntToStr(nRet));

    sArq := extractFilePath(Application.exename) + 'Fraseatendimento.wav';

    //Reproduz mensagem de atendimento
    if VoicerLib1.PlayFile(Port,sArq,'',0) = DG_EXIT_SUCCESS then
      MostraStatus(Port,'AfterPickup -> Reproduzindo mensagem ' + sArq)
    else
    begin
      MostraStatus(Port,'AfterPickup -> Arquivo '+ sArq + ' no encontrado...');
      //Desliga
      VoicerLib1.HangUp(Port);
      MostraStatus(Port,'AfterPickup -> Desligou...');

    end;
  except
    Application.MessageBox('Erro em AfterPickup', 'Except', mb_OK);
  end;
end;
procedure TForm1.voicerlib1RecordStop(ASender: TObject; Port,
  StopStatus: Smallint);
var
  nRet: Integer;  
begin

    //Desabilita as amostras de audio
    nRet := voicerlib1.DisableInputBuffer(Port);
    case nRet of
      DG_EXIT_SUCCESS:
        MostraStatus(Port,'OnRecordStop -> InputBuffer desabilitado com sucesso');
      DG_ERROR_DRIVER_CLOSED:
        MostraStatus(Port,'OnRecordStop -> DisableInputBuffer -> Driver desabilitado');
      DG_ERROR_PORT_OUT_OF_RANGE:
        MostraStatus(Port,'OnRecordStop -> DisableInputBuffer -> Parmetro porta fora do intervalo permitido, excedendo o nmero de portas instaladas');
      else
        MostraStatus(Port,'OnRecordStop -> Gerou excessao no DisableInputBuffer');
    end;
  //Desliga
  VoicerLib1.HangUp(Port);
  MostraStatus(Port,'OnRecordStop -> Desligou...');
end;

procedure TForm1.voicerlib1Recording(ASender: TObject; Port: Smallint;
  ElapsedTime: Integer);
var
  nMaxRecTime,nRet: integer;
begin
  //Le tempo mximo de gravao
  nMaxRecTime := strToInt(txtTempoGravacao.text);
  //Testa se atingiu limite
  if (ElapsedTime >= nMaxRecTime) and (nFlag = 0)then
  begin
    nFlag := 1;
    //Pra a gravacao
    nRet := VoicerLib1.StopRecordFile(Port);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'OnRecording -> Erro ao parar gravao.Ret.:' + IntToStr(nRet))
    else
      MostraStatus(Port,'OnRecording -> Parou gravao, esperando OnRecordStop');
      
    MostraStatus(Port,'OnRecording -> Parando a gravacao por tempo maximo');
  end;
end;

procedure TForm1.voicerlib1PlayStop(ASender: TObject; Port,
  StopStatus: Smallint);
var
  nRet : Integer;
begin
  if StopStatus = ssNormal then
  begin
    //Especifica o formato de gravacao
    VoicerLib1.SetRecordFormat(Port,ffWaveULaw);
    //Habilita o envio de amostras da placa para a aplicao
    nRet := voicerlib1.EnableInputBuffer(Port,DG_ENABLE);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'OnPlayStop -> Erro ao habilitar InputBuffer.nRet.:' + IntToStr(nRet)); 
    nFlag := 0 ;

    //Habilitou superviso de linha
    nRet := voicerlib1.EnableCallProgress(Port,CP_ENABLE_ALL);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'OnPlayStop -> Erro ao habilitar superviso de linha.nRet.:' + IntToStr(nRet))
    else
      MostraStatus(Port,'OnPlayStop -> Habilitou superviso de linha com sucesso');   

    //Desabilita o tempo de silncio caso esteja habilitado em testes seguidos
    voicerlib1.DisableSilenceDetection(Port);
    //Habilita detecco de silncio
    voicerlib1.EnableSilenceDetection(Port,StrToInt(txtTempoSilencio.Text),100);

    //Inicia Gravao de Recado
    nRet := VoicerLib1.RecordFile(Port,extractFilePath(Application.exename) +'gravacao.wav','');
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'Erro ao gravar recado')
    else 
      MostraStatus(Port,'OnPlayStop -> Gravando Mensagem em ' + extractFilePath(Application.exename) +'gravacao.wav');
  end;
end;

procedure TForm1.voicerlib1BusyDetected(ASender: TObject; Port: Smallint);
begin

  //Testa se esta falando a mensagem inicial
  if voicerlib1.IsPlaying(Port) then
  begin
    //Pra de falar a frase
    voicerlib1.StopPlayFile(Port);
    MostraStatus(Port,'OnBusyDetected -> Ocupado...Parando a frase...');
    //Desliga a porta
    VoicerLib1.HangUp(Port);
    MostraStatus(Port,'OnBusyDetected -> Desligou...');
  end
  else
  //Testa se ainda est gravando
  if voicerlib1.IsRecording(Port) then
  begin
    //Pra a gravacao
    VoicerLib1.StopRecordFile(Port);
    MostraStatus(Port,'OnBusyDetected -> Ocupado...Parando a gravacao...');
  end;
end;


procedure TForm1.voicerlib1SilenceDetected(ASender: TObject; Port,
  State: Smallint);
begin
  //Verifica se detectou silncio, se sim desliga
  if State = DG_SILENCE_DETECTED then
  begin
    MostraStatus(Port,'Silencio');
    VoicerLib1.HangUp(Port);
    MostraStatus(Port,'Desligou...');
  end;

end;

procedure TForm1.FormCreate(Sender: TObject);
var
  cVersao : array[0..255] of Char;
  nRet : Integer;
begin

  //Verifica a versao da dll e ocx da voicerlib
  nRet := voicerlib1.GetLibVersion(Cardinal(@cVersao),0);
  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(0,'Verso DLL ->- ' + cVersao)
  else
    MostraStatus(0,'Verso DLL -> Falha');

  nRet := voicerlib1.GetLibVersion(Cardinal(@cVersao),1);
  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(0,'Verso OCX -> ' + cVersao)
  else
    MostraStatus(0,'Verso OCX -> Falha');

end;

end.
